#include <stdio.h>
#include "bldc.h"

static volatile short zero_count = 0;

static void __attribute__((interrupt))
encz_handler ()
{
  zero_count = MTU7.TCNT;
}

main()
{
  int i;
  int old_halls = -1;
  int old_zcount = -1;
  int old_count = -1;
  int old_tgrc = -1;
  int enca, encb;

  bldc_init ();

  tty_puts("Hello from Encoder 3!\n");
  tty_puts("Simple chained encoder test\n");

  /* Shut off the motor.  */
  PORTB.DR.BYTE = UL | VL | WL;

  MTU8.TMDR.BIT.MD = 4; /* phase counting mode 1 */
  MTUB.TSTR.BIT.CST2 = 1; /* start MTU8 */

  MTU7.TMDR.BIT.MD = 0;
  MTU7.TCR.BIT.TPSC = 7;
  MTUB.TSTR.BIT.CST1 = 1; /* start MTU7 */

  printf("Looping...\n");
  while (1)
    {
      //int halls = PORTA.PORT.BYTE & 7;

      unsigned short count = MTU8.TCNT;


      enca = ENC_A ? 1 : 0;
      encb = ENC_B ? 1 : 0;

      PORT7.DR.BIT.B4 = enca;
      PORT7.DR.BIT.B5 = encb;


      if (count != old_count)
	{
	  old_count = count;
	  printf("Count: %04x %04x\r", MTU7.TCNT, count);
	  fflush (stdout);
	}
    }

  exit (0);
}
