#include <stdio.h>
#include "bldc.h"

#define STEPS_PER_ROT	200
#define ENC_PER_ROT	4000
#define ENC_PER_STEPS	(ENC_PER_ROT/STEPS_PER_ROT)
#define MINWAIT 300

int
main()
{
  long long old_sval = -4;
  int old_step = 4;
  int old_dir = 4;
  int power = 0;
  int torque;
  int then;
  int running = 0;

  bldc_init ();

  tty_puts("\033[1;1H\033[2J\n\nHello from Step/Dir 2!\n");

  simple_commutate (0);

  then = msec;

  SD_ESTOP_DDR = 1;

  while (1)
    {
      long long sval = step_direction_lval ();
      long long eval = encoder_lval ();
      long long motion;

      sval = sval * ENC_PER_ROT / STEPS_PER_ROT;

      motion = sval - eval;

      if (motion > ENC_PER_ROT/8)
	motion = ENC_PER_ROT/8;
      else if (motion < -ENC_PER_ROT/8)
	motion = -ENC_PER_ROT/8;
      else if (abs(motion) < ENC_PER_STEPS/3)
	motion = 0;

      torque = -power * motion / (ENC_PER_ROT/8);
      cpwm_torque (torque);

      if (tty_idle () && (msec - then) > MINWAIT)
	{
	  printf("\033[1;1Henc %8lld sdir %8lld  mot %8lld = %d   %x ",
		 eval, sval, motion, torque, (PORT9.PORT.BYTE >> 1) & 0x0f);
	  if (running)
	    printf("\033[32m%5d\033[0m  ", power);
	  else
	    printf("\033[31mstop!\033[0m  ");
	  temperature ();
	  printf("\033[K");
	  fflush (stdout);
	  then = msec;
	}

      if (tty_ready ())
	{
	  int c = tty_getc ();
	  switch (c)
	    {
	    case 'r':
	      bldc_run ();
	      running = 1;
	      break;

	    case 's':
	    case ' ':
	      bldc_stop ();
	      running = 0;
	      break;

	    case '0' ... '9':
	      if (c == '0')
		power = 32767;
	      else
		power = (c - '0') * 32767/10;
	      if (!running)
		{
		  bldc_run ();
		  running = 1;
		}
	      break;

	    case 'z':
	      step_direction_reset ();
	      break;
	    }
	}

      if (LIMIT1)
	SD_LIMIT1 = 1;
      else
	SD_LIMIT1 = 0;

      if (LIMIT2)
	SD_LIMIT2 = 1;
      else
	SD_LIMIT2 = 0;

      if (LIMIT3)
	SD_FAULT = 1;
      else
	SD_FAULT = 0;

      if (LIMIT4)
	SD_ESTOP_OUT = 1;
      else
	SD_ESTOP_OUT = 0;
    }
}
