#include <stdio.h>
#include <math.h>
#include "bldc.h"

#define DEAD 1
#define CYCLE 4096
#define MAXPOWER (CYCLE/2)

static double
dsin(int pos)
{
  double rad = pos * M_PI / 90.0;
  return sin(rad);
}

main()
{
  int power = 0;
  int pos, old_pos = -999;

  bldc_init ();

  tty_puts("Hello from Trap 2!\n");
  tty_puts("Simple trapezoid control using hall sensors in hardware\n");

  encoder_init ();
  cpwm_init ();

  printf("Stopped\n");

  printf("waiting for encoder sync\n");
  while (!encoder_synced())
    ;

  while (1)
    {
      if (tty_ready ())
	{
	  int c = tty_getc ();
	  switch (c)
	    {
	    case 'r':
	      printf("Running\n");
	      MTUB.TOER.BYTE = 0x3f;
	      break;

	    case 's':
	    case ' ':
	      printf("Stop\n");
	      MTUB.TOER.BYTE = 0x00;
	      break;

	    case '0' ... '9':
	      if (c == '0')
		power = 32700;
	      else
		power = (c - '0') * 32767/10;
	      printf("max power %d\n", power);
	      old_pos = -999;
	      break;
	    }
	}

      pos = encoder_val ();
      if (pos != old_pos)
	{
	  old_pos = pos;
	  printf("pos = %d, power = %d\033[K\n", pos, power);
	  cpwm_levels (power * dsin(pos), power * dsin(pos+120), power * dsin(pos+240));
	}
      
    }

  exit (0);
}
